/**
  *********************************************************************************
  * @file    	    touch.h
  * @author  	    FMD AE
  * @brief   	    ͷļ
  * @version 	    V2.0.1           
  * @data		    2022-04-08
  *********************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  *Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  **********************************************************************************
  */  

  /**********************************************************************************
  * @оƬԴ
  * 1. Device: FT62F13X
  * 2. Memory: Flash 3KX14b, SRAM:256X8b EEPROM 128X8b 
  *
  * @ʹԴ˵:
  * 1. TIMER0TIMER1
  * 2. LVDж
  * 3. ROM & SARM (Key= 1,Ks=1led.c)  
  *                 		  ROM *14b       	SRAM*8b			
  * touch_soft.lpp		1,151+3*Key	52+8*Key
  * touch.lpp		1,262+3*Key	55+8*Key
  * touch_cs_ac.lpp		1,400+4*Key	62+8*Key
  * touch_cs_uac.lpp		1,473+4*Key	65+8*Key
  * touch_lp.lpp		1,650+3*Key	59+8*Key+2*Ks
  * touch_cs_lp_ac.lpp	1,790+4*Key	64+8*Key+2*Ks
  * touch_cs_lp_uac.lpp	1,844+4*Key	67+8*Key+2*Ks
  *
  * 4.SRAMַָ:
  * 	ַָ Ӧö壺0x20 0x21 0x72~ 0x79
  * 	ַָ ݱ8BYTE/ (0x120 ~ 0x120 + 8*Key)
  **********************************************************************************
  */
 
#ifndef _TOUCH_H
#define _TOUCH_H

///////////ͷļ/////////////////////////////////////
#include <string.h>
#include "SYSCFG.h"

/////////////ϵͳʱ///////////////////////////////////////////
#define SYS_OSCCON   0B01110001

/////////ӦоƬKEYIOӳ䶨//////////////////////////
#define   KEY0_INDEX_MAP       7
#define   KEY1_INDEX_MAP       6
#define   KEY2_INDEX_MAP       5
#define   KEY3_INDEX_MAP       4
#define   KEY4_INDEX_MAP       2
#define   KEY5_INDEX_MAP       3
#define   KEY6_INDEX_MAP       0
#define   KEY7_INDEX_MAP       1

#define   KEY_NUMBER   		   8  //Ŀǰ8
const unsigned char ucKeyNumberMax = KEY_NUMBER;
unsigned int stTkData[KEY_NUMBER][4] @ 0x120;
const unsigned char ucKeyIndexMapArray[KEY_NUMBER]=
{
    KEY0_INDEX_MAP,
    KEY1_INDEX_MAP,
    KEY2_INDEX_MAP,
    KEY3_INDEX_MAP,
    KEY4_INDEX_MAP,
    KEY5_INDEX_MAP,
    KEY6_INDEX_MAP,
    KEY7_INDEX_MAP
};
/////////////Чֵ////////////////////////////////////
#define   KEY0_ON					35 
#define   KEY1_ON					35 
#define   KEY2_ON					35 
#define   KEY3_ON					35 
#define   KEY4_ON					35 
#define   KEY5_ON					35 
#define   KEY6_ON					35 
#define   KEY7_ON					35 
const unsigned char ucActiveSensorDeltaArray[KEY_NUMBER]=
{
 KEY0_ON,  KEY1_ON,  KEY2_ON,  KEY3_ON,  KEY4_ON,  KEY5_ON,  KEY6_ON,  KEY7_ON  
};
///////////Чֵ//////////////////////////////////////
#define   KEY0_OFF					24
#define   KEY1_OFF					24
#define   KEY2_OFF					24
#define   KEY3_OFF					24
#define   KEY4_OFF					24
#define   KEY5_OFF					24
#define   KEY6_OFF					24
#define   KEY7_OFF					24
const unsigned char ucInActiveSensorDeltaArray[KEY_NUMBER]=
{
 KEY0_OFF,  KEY1_OFF,  KEY2_OFF,  KEY3_OFF,  KEY4_OFF,  KEY5_OFF,  KEY6_OFF,  KEY7_OFF 
};

////////״̬CSģʽµж///////////////////////////////////////////
#define RESONANCE_CHANGER_FREQ_COUNT_FILTER            1000 	// ʱ
const unsigned int uiResonanceChangerFreqCountFilter = RESONANCE_CHANGER_FREQ_COUNT_FILTER;	
#define RESONANCE_DATA_FILTER                   16  //	仯һΧΪǹ
const unsigned char ucResonanceDataFilter = RESONANCE_DATA_FILTER;
//////CS״̬¶///////////////////////////////////////////////////////////////
#define ABNORMAL_WAIT_COUNT_FILTER              1000 	//쳣״̬¶Чʱ
const unsigned int uiAbnormalWaitCountFilter = ABNORMAL_WAIT_COUNT_FILTER;	
#define NORMAL_COUNT_FILTER                     200  	//жϴ200ξͻָģʽ
const unsigned char ucNormalCountFilter = NORMAL_COUNT_FILTER;
#define ABNORMAL_COUNT_FILTER                   3   	//쳣жϴ3ξͽCSģʽ
const unsigned char ucAbnormalCountFilter = ABNORMAL_COUNT_FILTER;
#define KEY_OFF_ABNORMAL_UP_FILTER              5  		//ǰֵ쳣ֵ
const unsigned char ucKeyOffAbnormalUpFilter = KEY_OFF_ABNORMAL_UP_FILTER;
#define KEY_ON_ABNORMAL_UP_FILTER            	5 		//ֵ쳣
const unsigned char ucKeyOnAbnormalUpFilter = KEY_ON_ABNORMAL_UP_FILTER;
#define KEY_ON_ABNORMAL_DOWN_FILTER             16 		//ֵ쳣
const unsigned char ucKeyOnAbnormalDownFilter = KEY_ON_ABNORMAL_DOWN_FILTER;

//////ɼݴض///////////////////////////////////////////////////
#define MULTIPLE_1   					80    	//Ŵ
#define STRONG_FILTER_1   				4		//˲
#define SINGLE_FILTER_1  				4		//˲
#define BASE_LINE_DOWN_SPEED_1   		64    	//¸ٶ
#define BASE_LINE_UP_SPEED_1  			64	    //¸ٶ
#define BASE_LINE_EQUAL_UP_SPEED_1   	100		//Ͽٸ
#define BASE_LINE_EQUAL_DOWN_SPEED_1   	200		//¿ٸ
#define SIGNAL_NOISE_RATIO_1  			30    	//
#define MEANTIME_MAX_KEY_NUM_1  		KEY_NUMBER		//󰴼
const unsigned char ucMultiple = MULTIPLE_1;
const unsigned char ucStrongFilter = STRONG_FILTER_1;
const unsigned char ucSingleFilter = SINGLE_FILTER_1;
const unsigned char ucBaselineDownSpeed = 128 + BASE_LINE_DOWN_SPEED_1;
const unsigned char ucBaselineUpSpeed = 128 - BASE_LINE_UP_SPEED_1;
const unsigned char ucBaselineEqualUpSpeed = BASE_LINE_EQUAL_UP_SPEED_1;
const unsigned char ucBaselineEqualDownSpeed = BASE_LINE_EQUAL_DOWN_SPEED_1;
const unsigned char ucSignalNoiseRatio = SIGNAL_NOISE_RATIO_1;	
const unsigned char ucMeantimeMaxKeyNum = MEANTIME_MAX_KEY_NUM_1;

////////Ƶ΢////////////////////////////////////////////////////////
#define FREQ_CHANGER_1	0X20	//ɨƵ
#define FREQ_CHANGER_2 	0X00	//ɨƵ
#define FREQ_CHANGER_3	0XE0	//ɨƵ
const unsigned char ucFreqChangerBase = FREQ_CHANGER_2;
const unsigned char ucFreachooseArray[3] = {
    FREQ_CHANGER_1,
    FREQ_CHANGER_2,
    FREQ_CHANGER_3
};
////////͹Ķ///////////////////////////////////////////////////
////////͹Ķ///////////////////////////////////////////////////
#define SLEEP_MODE_BASE_LINE_COUNT   10   //˯ģʽµϸ
const unsigned char ucSleepBaseLineCount = SLEEP_MODE_BASE_LINE_COUNT; 
#define SLEEP_MODE_WAIT_NUMBER     250 //ٴް½͹,аһ
const unsigned char ucSleepModeWaitNumber = SLEEP_MODE_WAIT_NUMBER;
#define SLEEP_UPDATA_BASE_WAIT_NUMBER  15 //ÿ2sɨһΣô 2000/128 = 15
const unsigned char ucSleepUpdataBaseNumber = SLEEP_UPDATA_BASE_WAIT_NUMBER;
#define SLEEP_KEY_ON_VALUE    	   20  //͹İЧֵ
const unsigned char ucSleepKeyOnValue = SLEEP_KEY_ON_VALUE;
#define SLEEP_RATE_SET0     0B00001111      // 1/4096
#define SLEEP_RATE_SET1     0B00001111      // 1/8192
const unsigned char ucSleepRateSet0 = SLEEP_RATE_SET0;
const unsigned char ucSleepRateSet1 = SLEEP_RATE_SET1;
//////////////io setting,˴޸////////////////////////////////
#define SLEEP_SCAN_KEY_GROUP       4  	// ȡֵΧ 1~4
const unsigned char ucSleepGroupMax = SLEEP_SCAN_KEY_GROUP;
unsigned int uiSleepGroupBuffer[SLEEP_SCAN_KEY_GROUP];
#define 	TouchIoMaskB 	 0x03
#define 	TouchIoMaskC 	 0xFC
const unsigned char ucTouchIoMaskB = TouchIoMaskB;	
const unsigned char ucTouchIoMaskC = TouchIoMaskC;
#define   	SleepTrisB_0	 0x00
#define   	SleepTrisC_0     0x03
#define   	SleepTK_0        0x03
#define   	SleepTrisB_1	 0xC0
#define   	SleepTrisC_1     0x00
#define   	SleepTK_1        0x0C
#define   	SleepTrisB_2	 0x30
#define   	SleepTrisC_2     0x00
#define  	SleepTK_2        0x30
#define   	SleepTrisB_3	 0x0C
#define   	SleepTrisC_3     0x00
#define   	SleepTK_3        0xC0
const unsigned char ucSleepTrisB_0 = SleepTrisB_0;	
const unsigned char ucSleepTrisC_0 = SleepTrisC_0;
const unsigned char ucSleepTK_0 = SleepTK_0;
const unsigned char ucSleepTrisB_1 = SleepTrisB_1;	
const unsigned char ucSleepTrisC_1 = SleepTrisC_1;
const unsigned char ucSleepTK_1 = SleepTK_1;
const unsigned char ucSleepTrisB_2 = SleepTrisB_2;	
const unsigned char ucSleepTrisC_2 = SleepTrisC_2;
const unsigned char ucSleepTK_2 = SleepTK_2;
const unsigned char ucSleepTrisB_3 = SleepTrisB_3;	
const unsigned char ucSleepTrisC_3 = SleepTrisC_3;
const unsigned char ucSleepTK_3 = SleepTK_3;
//
extern volatile bit bSleepScanEnable;//͹ɨ־
extern volatile bit bSleepMode;//͹Ľ־
extern volatile bit bSleepUserFlag;//͹ûʹܱ־ֻеûʹܸñ־˲ܽ͹
extern volatile bit bIEBackupsFlag;//͹µжϱ־λ 
extern volatile bit bSleepUserWakeFlag;//͹ûʹܱ־ûͨ־ǿƻ˳͹
//ܺ
unsigned char TSC_SleepPrcoessing(void);//͹µĻѴ
///////////͹Ķ/////////////////////////////////////

///////////ܺ/////////////////////////////////////
void TOUCH_INITIAL(void);  //óʼ          
void TSC_Start(void); //ɨÿֻһһɨ账
void TSC_Reset(void); //λ. ʹ
unsigned char TSC_DataProcessing(void);//аݴ״̬: 1ʾаݴ 0ʾδ
unsigned char TSC_GetStrongest(void);  //ȡǿֵ
unsigned char TSC_GetSingle(void); //ȡЧ־ÿbitʾһ1Ϊа£0Ϊް
unsigned char TSC_GetDelta(unsigned char KeyNum); //ȡ仯, >󰴼KEY_NUMBERȡֵ 
unsigned int TSC_GetPrevData(unsigned char KeyNum); //ǰɼֵ
    
#endif
