/**
  *********************************************************************************
  * @file    	    main.c
  * @author  	    FMD AE
  * @brief   	    Device: FT62F13X
  *                             Memory: Flash 3KX14b, SRAM:256X8b EEPROM 128X8b  
  *                             touchʹʾ	
  * @version 	    V2.0.0           
  * @data		    2021-12-29
  *********************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  *Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  **********************************************************************************
*/
//===========================================================
//include definition
//===========================================================
#include	"SYSCFG.h";
#include	"touch.h";

//===========================================================
//Variable definition
//===========================================================

extern void SendDataToPC(void);

/******************************************************************************
  * @brief  DelayUs program
  * @Description  ʱ
  * @param  time
  * @note   
  * @retval  None
  *****************************************************************************
*/

void DelayUs(unsigned int Time)
{    
	unsigned int a;
	for(a=0;a<Time;a++)
	{
		NOP();
	}
}

/******************************************************************************
  * @brief  interrupt ISR	program
  * @Description  жں
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void interrupt ISR(void)  
{ 
    
}  

/******************************************************************************
  * @brief  SYS_INITIAL	program
  * @Description  ϵͳʱӡIOʼ
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void SYS_INITIAL (void) 
{
	OSCCON = SYS_OSCCON;   //0B01110001 //WDT 32KHZ IRCF=110=16MHZ/4=4MHZ,0.25US/T
							//Bit0=1,ϵͳʱΪڲ
							//Bit0=0,ʱԴFOSC<20>ѡʱѡ
                            
	OPTION = 0B00001000;	//Bit3 PSA   ԤƵλ 0= ԤƵTimer0ģ 1WDT 
							//Bit20ԤƵѡλ 000: 1:2 
									   
	INTCON = 0;  			//ݽֹж
		
	PORTA = 0B00000000;
	PORTC = 0B00000000;
	PORTB = 0B00000000;
		
	TRISA = 0B11111111;		// 0- 1-   PA2(TKCAP) set input
	TRISB = 0B11111111;		// B2-B7  TK7-TK2
	TRISC = 0B11111111;     // C0-C1  TK1-TK0
		
	WPUA = 0B00000000;     	//PA˿ 1- 0-
	WPUB = 0B00000000;
		
	ANSEL0 = 0B00000100;      // TKCAP A2Ϊģ	

	TX_IO_ADDR &= ~TX_IO;			  
}

/******************************************************************************
  * @brief  WDT_INITIAL	program
  * @Description  ʼÿŹΪ16λSLEEPģʽ128ms
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void WDT_INITIAL (void) 
{
	CLRWDT();              //忴Ź
	WDTCON = 0B00001111;   //bit[6:5]WCKSRC=00=LIRC(32K) 
						   //bit[4:1]WDTPS=0110=1:2048,ԤƵ1:1 ʱʱ=(4096*1)/32000=128ms  
						   //bit[0]SWDTEN= 1                       	                  
}


/******************************************************************************
  * @brief  main	program
  * @Description 
  * @param  None
  * @note   
  * @retval  None
  *****************************************************************************
*/

void main(void)
{ 
	SYS_INITIAL(); //ϵͳʱӡIOʼ   
	TOUCH_INITIAL();//ʼ
	WDT_INITIAL(); //Źʼ
	PEIE = 1;  //ʹж
	GIE = 1; //ʹȫж
		
	while (1)
	{
		//忴Ź   
		CLRWDT();   
		
		//ɨ  
		TSC_Start(); 

		DelayUs(5000);
	    DelayUs(5000); //20220401 ʱ30msϴλ
		DelayUs(5000); //20220407 ʱ30msϴλ
         
		SendDataToPC();
		
        _nop();
        _nop();
	}     
}

//===========================================================
