/**
  *********************************************************************************
  * @file    	    main.c
  * @author  	    FMD AE
  * @brief   	    Device: FT62F13X
  *                 Memory: Flash 3KX14b, SRAM:256X8b EEPROM 128X8b  
  *                 touchʹʾ	
  * @version 	    V2.0.1           
  * @data		    2022-04-08
  *********************************************************************************
  * @attention
  * COPYRIGHT (C) 2021 Fremont Micro Devices Corporation All rights reserved.
  *    This software is provided by the copyright holders and contributors,and the
  *software is believed to be accurate and reliable. However, Fremont Micro Devices
  *Corporation assumes no responsibility for the consequences of use of such
  *software or for any infringement of patents of other rights of third parties,
  *which may result from its use. No license is granted by implication or otherwise
  *under any patent rights of Fremont Micro Devices Corporation.
  **********************************************************************************
*/


/* Includes ----------------------------------------------------------------------*/

#include	"SYSCFG.h";
#include	"touch.h";
#include	"led.h";

//===========================================================
//Variable definition
//===========================================================
unsigned char strongest = 0; //demo-test
unsigned char Sav_strongest = 0; //demo-test


/**********************************************************************************
  * @brief  DelayUs  program.
  * @param  time
  * @note   ϵͳʱ
  * @retval None
  *********************************************************************************
*/
void DelayUs(unsigned int Time) 
{    
	unsigned int a;
	for(a=0;a<Time;a++)
	{
		NOP();
	}
}

/**********************************************************************************
  * @brief  interrupt ISR  program.
  * @param  None
  * @note   м̺
  * @retval None
  *********************************************************************************
*/
void interrupt ISR(void) 
{ 
    //жϺ
}  

/**********************************************************************************
  * @brief  SYS_INITIAL  program.
  * @param  None
  * @note   ϵͳʱӡIOʼ
  * @retval None
  *********************************************************************************
*/

void SYS_INITIAL (void) 
{
	OSCCON = SYS_OSCCON; //0B01110001  //WDT 32KHZ IRCF=110=16MHZ/4=4MHZ,0.25US/T
											//Bit0=1,ϵͳʱΪڲ
											//Bit0=0,ʱԴFOSC<20>ѡʱѡ
	OPTION = 0B00001000;	 //Bit3 PSA   ԤƵλ 0= ԤƵTimer0ģ 1WDT 
											//Bit20ԤƵѡλ 000: 1:2 
		                           
	INTCON = 0;  			//ݽֹж
    
	PORTA = 0B00000000;
    PORTC = 0B00000000;
    PORTB = 0B00000000;
    
	TRISA = 0B00000100;		// 0- 1-   PA2(TKCAP) set input
    TRISB = 0B00000000;		// B2-B7  TK7-TK2
    TRISC = 0B00000000;     // C0-C1  TK1-TK0
    
	WPUA = 0B00000000;     	//PA˿ 1- 0-
    WPUB = 0B00000000;
    
    ANSEL0 = 0B00000100;      // TKCAP A2Ϊģ			  
}

/**********************************************************************************
  * @brief  WDT_INITIAL  program.
  * @param  None
  * @note   ʼÿŹΪ16λSLEEPģʽ128ms
  * @retval None
  *********************************************************************************
*/

void WDT_INITIAL (void) 
{
	CLRWDT();              //忴Ź
	WDTCON = 0B00001111;   //bit[6:5]WCKSRC=00=LIRC(32K) 
						   //bit[4:1]WDTPS=0111=1:4096,ԤƵ1:1 ʱʱ=(4096*1)/32000=128ms  
						   //bit[0]SWDTEN= 1                       	                  
}

/**********************************************************************************
  * @brief  Sleep_Enable  program.
  * @param  None
  * @note   ˯ߵش
  * @retval None
  *********************************************************************************
*/

void Sleep_Enable(void)
{ 
   if(bSleepMode == 1)
   {
       bSleepMode = 0;
       
//////////͹Ĵ޸///////////////////////
	   TKEN = 0; //Ĵ 			 
	   TKCON1 = 0;//ðɨͨ   	                
	   LVDEN = 0;//LVD ر					         
	   T0CON0 = 0x01;//T0CKRUN =0;     
	   /////////////////	           
	   SLEEP(); //˯                    
	   ///////////////// 
	   T0CON0 = 0x05; //T0CKRUN =1;         			         
	   LVDEN = 1;//LVD       	                 
	   bSleepScanEnable = 1;//˯ɨ
//////////͹Ĵ޸///////////////////////
	}
}

/**********************************************************************************
  * @brief  main  program.
  * @param  None
  * @note   
  * @retval None
  *********************************************************************************
*/

void main(void)
{ 
    SYS_INITIAL(); //ϵͳʱӡIOʼ
    
    //////////////////////////////////////////////////
    //touchԴʹ뿴touch.h˵
    TOUCH_INITIAL();//ʼ
    //͹Ķʱر 
	WDT_INITIAL(); //Źʼ
    //////////////////////////////////////////////////
    
    PEIE = 1;  //ʹж
	GIE = 1; //ʹȫж   
    
    ////demo-test////
    LED(); //led.c
    ////demo-test////
    
	////͹Ĵ־////////////////////
    bSleepUserFlag = 1;   //Ϊ1ʾɽ͹ģûʹ־ǷҪ͹״̬
    bSleepUserWakeFlag = 0; //Ϊ1ʾǿ˳͹ģûʹ־Ƿǿ˳ͺ
    ////͹Ĵ־////////////////////
    
//    //////demo_test/////////////////////
//	TRISA |= 0B00000001; //PA0Ϊ
//   //////demo_test/////////////////////
     
    while (1)
    {
		//忴Ź   
	    CLRWDT();   
        
//////////͹Ĵ޸///////////////////////
        if(bSleepScanEnable == 1)
        {
//            //////demo_test/////////////////////
//            if(PA0==1)//⵽PA0ߵƽbSleepUserWakeFlag1
//            {
//                bSleepUserWakeFlag = 1; //Ϊ1ʾǿ˳͹ģûʹ־Ƿǿ˳ͺ
//            }
//            //////demo_test/////////////////////
            
            if(TSC_SleepPrcoessing()==1) //ѣ˳͹ģʽ
            {
                GIE = bIEBackupsFlag;
                bSleepUserWakeFlag = 0; //ǿƻѱ־
                //////--start--˳͹ģʽûԶ崦/////                
				//ûԶ崦
                
                //////--end---˳͹ģʽûԶ崦/////
            }                                                    				          
        }
        else
//////////͹Ĵ޸///////////////////////
        {  
            //ɨ  
			TSC_Start(); 
                              
			if(TSC_DataProcessing() == 1 )//1ʾаһΡ
            {			            		                          		 
				/////////////demo-test////////////////////           
				strongest = TSC_GetStrongest(); 
				if(Sav_strongest != strongest)
				{
					LED_Scan(); //led.c аʱӦĵ
				}
				Sav_strongest = strongest;  
				/////////demo-test////////////////////
                              	
				if(bSleepMode == 1) //1ΪʾҪ͹
                {                                						
                  bIEBackupsFlag = GIE;     
                  GIE = 0;           
                 ////start--͹ûԶ崦////////////////////	
                 
         		 ////end---͹ûԶ崦/////////////////////             
                }  
            }  
                       
///////start----ûԶ崦ﴦȻӰ͹////////////////        
            
//ûԶ崦

///////end----ûԶ崦ﴦȻӰ͹//////////////////    
            
        }   
                		
//////////͹Ĵ޸////////////////////////////////////////
        Sleep_Enable();       
//////////͹Ĵ޸///////////////////////////////////////
    }     
}

//===========================================================
