/* ļTEST_61F02x_ADC.C
* ܣ   FT61F02x-ADCʾ
* IC:      FT61F023 SOP16
*    16M/2T                    
* ˵   AN2(PA2)ڵĵѹPWM3P(PC4)ռձ
*		   AN2ŵѹԽ(0-VDD)PWM3(PC2)ռձԽ(2K,0-99%)	
*
*               FT61F023  SOP16 
*               ---------------
*  VDD---------|1(VDD)  (VSS)16|--------GND     
*  NC----------|2(PA7)  (PA0)15|---------NC 
*  NC----------|3(PA6)  (PA1)14|---------NC
*  NC----------|4(PA5)  (PA2)13|--------AN2
*  NC----------|5(PC3)  (PA3)12|---------NC
*  NC----------|6(PC2)  (PC0)11|---------NC
*  NC----------|7(PA4)  (PC1)10|---------NC
*  NC----------|8(PC5)  (PC4)09|-------PWM3
*			    ---------------
*/
#include "SYSCFG.h"
//*************************궨***************************
#define  unchar     unsigned char 
#define  unint      unsigned int

//PWM
#define  PWM3Dir  	TRISC4

volatile unint    	TestADC;
/*-------------------------------------------------
* POWER_INITIAL
* ܣ  ϵϵͳʼ
* 룺  
*   
 --------------------------------------------------*/	
void POWER_INITIAL (void) 
{ 
    OSCCON = 0B01110001;			//IRCF=111=16MHz/2T=8MHz,0.125us
	INTCON = 0;  					//ݽֹж
    
	PORTA = 0B00000000;		
	TRISA = 0B00000100;				//PA 1- 0-
									//PA2-
	PORTC = 0B00000000; 	
	TRISC = 0B00000000;				//PC 1- 0-
	WPUA = 0;          				//ֹPA
	WPUC = 0;       				//ֹPC
    
	OPTION = 0B00001000;			//Bit3=1,WDT MODE,PS=000=WDT RATE 1:1
    MSCKCON = 0B00000000;
    //Bit6:	0-ֹPA4PC5ѹ
	//Bit5:	0-TIMER2ʱΪFosc
	//Bit4:	0-ֹLVR       
	CMCON0 = 0B00000111; 			//رձȽCxINΪIO
}
/*------------------------------------------------- 
* DelayUs
* ܣ  ʱ --16M-2T--ſ1%.
* 룺  Time ʱʱ䳤 ʱʱTime Us
*    
 -------------------------------------------------*/
void DelayUs(unsigned char Time)
{
	unsigned char a;
	for(a=0;a<Time;a++)
	{
		NOP();
	}
}  
/*-------------------------------------------------
* : ADC_INITIAL
* ܣ  ADCʼ
* 룺  
*   
 --------------------------------------------------*/
void ADC_INITIAL (void) 
{
	ADCON1 = 0B01100000;
    //DIVS=0,ʱѡFOSC
	//ADCS[2:0]=110,ƵFOSC/64
    
	ADCON0 = 0B10001001;
    //Bit7:		ADFM=1,Ҷ                     
	//Bit[6:5]: VCFGοѹ
    //			00-οѹVDD
	//			01-οѹڲ2V
    //			10-οѹڲ3V
	//			11-οѹVref
	//Bit[4:2]:	CHS=010-ѡAN2ͨ
	//Bit1:		GO,ADת״̬λ
	//Bit0:		ADON=1,ADCʹ
	ANSEL = 0B00000100;   			//ʹAN2Ϊģ	
}                      
/*-------------------------------------------------
* : GET_ADC_DATA
* ܣ  ȡͨADCֵ
* 룺  AN_CN ͨ
*   INTADֵ(β˲)
 --------------------------------------------------*/
unint GET_ADC_DATA (unchar AN_CH) 
{ 
	unchar	i;
	unchar	ADCON0Buff; 
	unint	tBuffer = 0;
	unint	ADC_DATA=0;
	 
	ADCON0Buff = ADCON0 & 0B11100011;//ֵͨ

	AN_CH <<=2;              
	ADCON0Buff |=  AN_CH;   		//Bit[4:2]:CHS=010,ѡAN2ͨ      

	ADCON0 = ADCON0Buff; 			//¼ֵͨ
    DelayUs(20); 
	GO_DONE = 1;             		//ADC 
	while( GO_DONE==1 );    		//ȴADCת

	ADC_DATA =  ADRESH;
	ADC_DATA <<=8;
	ADC_DATA |= ADRESL;      		//10Bit ADCֵ
	tBuffer =  ADC_DATA;
	return  tBuffer;
} 
/*-------------------------------------------------
* PWM_INITIAL
* ܣ  PWMʼ
*  = 2^TMRxPS*2^Nbit*TPxCK
*		   = 2^0*2^8*[(T3CKDIV+1)/16000000]
*		   = 1*256*[(30+1)/16000000] = 0.496ms
*  = 2TMRxPS*(PRx)*TPxCK
*		   = 2^0*128*[(T3CKDIV+1)/16000000]
*		   = 1*128*[(30+1)/16000000] = 0.248ms
 --------------------------------------------------*/
void PWM_INITIAL (void) 
{
	PWM3Dir =1; 					//PWM3PINΪģʽ

	PWM3CR0 = 0B00110010;
    //Bit7:		жѡλ 0-ʱж
	//Bit[6:4]:	λѡ 011-8λ
	//Bit[3:1]:	ʱѡ   001-ڲRCʱ/(T3CKDIV+1)
	//Bit0:		PWM/BUZZERѡ 0-PWM 
	PWM3CR1 = 0B10000000;
	//Bit7:		1-TMR3ΪPWM/BUZZERģʽ
	//Bit6:		0-PWM3ΪߵƽЧ
	//Bit[5:3]:	000-PWM3ԤƵΪ1:1
	//Bit2:		0-ݹTMR3
	//Bit1:		0-ֹTMR3ж
	//Bit0:		0-TMR3жϱ־λֻ
	TMR3H=0;
	T3CKDIV = 30;
	PR3L = 128;						//ռձ 50%
}
/*-------------------------------------------------
* :  main
* ܣ  
* 룺  
*   
 --------------------------------------------------*/
void main()
{
	POWER_INITIAL();		        //ϵͳʼ
	ADC_INITIAL();			        //ADCʼ	
	PWM_INITIAL();					//PWMʼ
	TMR3ON = 1;				        //T3PWM3
	PWM3Dir = 0; 			        //PWM3 PINΪģʽPWM
	while(1)
	{
		TestADC = GET_ADC_DATA(2); 	//ͨ2ADֵ
		PR3L =  TestADC >> 2; 		//ADֵֵPWMPR3LPWM3Pռձ
							
		NOP();
		NOP();	 
	}
}
