//********************************************************* 
/* ļTEST_61F02x_IIC.c
* ܣ   FT61F02x-IICʾ
* IC:      FT61F023 SOP16
*    16M/4T                    
* ˵   ʾλ61F02x_IICʾ.
*		   óȡ(24C02)0x12ֵַ,ȡ0x13ַ
* 
*                  FT61F023  SOP16 
*                 ----------------
*  VDD-----------|1(VDD)   (VSS)16|-----------GND     
*  NC------------|2(PA7)   (PA0)15|------------NC 
*  NC------------|3(PA6)   (PA1)14|------------NC
*  NC------------|4(PA5)   (PA2)13|-------IIC_SDA
*  NC------------|5(PC3)   (PA3)12|------------NC
*  NC------------|6(PC2)   (PC0)11|------------NC
*  IIC_SCL-------|7(PA4)   (PC1)10|------------NC
*  NC------------|8(PC5)   (PC4)09|------------NC
*			      ----------------
*/
//*********************************************************
#include "SYSCFG.h"
//***********************궨*****************************
#define	unchar	unsigned char 

#define	IIC_SCL	PA4   
#define	IIC_SDA	PA2

#define	SDA_OUT	TRISA2 = 0
#define	SDA_IN	TRISA2 = 1

unchar IICReadData;
/*-------------------------------------------------
* POWER_INITIAL
* ܣ  ϵϵͳʼ
* 룺  
*   
--------------------------------------------------*/	
void POWER_INITIAL (void) 
{
	OSCCON = 0B01110001;	//IRCF=111=16MHz/4T=4MHZ,0.25us
	INTCON = 0;				//ݽֹж
	PORTA = 0B00000000;				
	TRISA = 0B00000000;		//PA 0- 1-
  	PORTC = 0B00000000; 	
	TRISC = 0B00000000;		//PC 0- 1-  
    WPUA = 0B00000000;		//PA˿ 1- 0-
    WPUC = 0B00000000;		//PC˿ 1- 0-

	ANSEL = 0B00000000;
	OPTION = 0B00001000;	//Bit3=1,WDT MODE,PS=000=WDT RATE 1:1
    MSCKCON = 0B00000000;
    //Bit6->0,ֹPA4PC5ѹ
	//Bit5->0,TIMER2ʱΪFosc
	//Bit4->0,ֹLVR       
	CMCON0 = 0B00000111;	//رձȽCxINΪIO
}
/*-------------------------------------------------
* ƣDelayUs
* ܣ   ʱ --16M-4T--ſ1%.
* Time ʱʱ䳤 ʱʱTime*2 Us
* ز 
 -------------------------------------------------*/
void DelayUs(unsigned char Time)
{
	unsigned char a;
	for(a=0;a<Time;a++)
	{
		NOP();
	}
}                  
/*-------------------------------------------------
* IIC_Start
* ܣ  IICʼź
* 룺  
*   
 --------------------------------------------------*/
void IIC_Start(void)
{
	SDA_OUT;              //SDA
	IIC_SDA=1;	  	  
	IIC_SCL=1;
	DelayUs(10);
 	IIC_SDA=0;            //ʼź:SCLΪߵƽʱSDAɸߵƽΪ͵ƽ
	DelayUs(10);
	IIC_SCL=0;            //ǯסI2Cߣ׼ͻ 
    DelayUs(10);
}	  
/*-------------------------------------------------
* IIC_Stop
* ܣ  IICֹͣź
* 룺  
*   
 --------------------------------------------------*/
 void IIC_Stop(void)
{
	SDA_OUT;              //SDA
	IIC_SCL=0;
	IIC_SDA=0;            //ֹźţSCLΪߵƽʱSDAе͵ƽ䵽ߵƽ
 	DelayUs(10);
	IIC_SCL=1;
    DelayUs(10); 
	IIC_SDA=1;            //I2C߽ź
	DelayUs(10);							   	
}
/*-------------------------------------------------
* IIC_Wait_Ack
* ܣ  ȴӦźŵ
* 룺  
*   ֵ1Ӧʧ
*                 0Ӧɹ
 --------------------------------------------------*/
unsigned char IIC_Wait_Ack(void)
{
	unsigned char ucErrTime=0;      
	SDA_IN;               //SDAΪ  
	IIC_SDA=1;
	DelayUs(5);	   
	IIC_SCL=1;
	DelayUs(5);	 
	while(IIC_SDA)
	{
		ucErrTime++;
		if(ucErrTime>250) //ȴʱ
		{
			IIC_Stop();
			return 1;
		}
	}
	IIC_SCL=0;            //ʱ0 	   
	return 0;  
} 
/*-------------------------------------------------
* IIC_Ack
* ܣ  ACKӦ
* 룺  
*   
 --------------------------------------------------*/
void IIC_Ack(void)
{
	IIC_SCL=0;
	SDA_OUT;              //SDA
	IIC_SDA=0;
	DelayUs(5);	
	IIC_SCL=1;
	DelayUs(5);	
	IIC_SCL=0;
}
/*-------------------------------------------------
* IIC_NAck
* ܣ  ACKӦ
* 룺  
*   
 --------------------------------------------------*/	    
void IIC_NAck(void)
{
	IIC_SCL=0;
	SDA_OUT;              //SDA
	IIC_SDA=1;
	DelayUs(5);	
	IIC_SCL=1;
	DelayUs(5);	
	IIC_SCL=0;
}					 				     
/*-------------------------------------------------
* IIC_Send_Byte
* ܣ  IICһֽ
* 룺  дҪ͵һֽtxd
*   
 --------------------------------------------------*/		  
void IIC_Send_Byte(unsigned char txd)
{                        
    unsigned char t;   
	SDA_OUT;	          //SDA   
    IIC_SCL=0;            //ʱӿʼݴ
    for(t=0;t<8;t++)
    {              
		if((txd&0x80)>>7)
			IIC_SDA=1;
		else
			IIC_SDA=0;
		txd<<=1; 	  
		DelayUs(5);				  
		IIC_SCL=1;
		DelayUs(5);	
		IIC_SCL=0;	
		DelayUs(5);
    }	 
} 	    
/*-------------------------------------------------
* IIC_Read_Byte
* ܣ  IICһֽ
* 룺  
*   洢ݲreceive
 --------------------------------------------------*/
 unsigned char IIC_Read_Byte(void)
{
	unsigned char i,receive=0;
	SDA_IN;               //SDAΪ
    for(i=0;i<8;i++ )
	{
        IIC_SCL=0; 
        DelayUs(5);	
     	IIC_SCL=1;
        receive<<=1;
        if(IIC_SDA)receive++;   
		DelayUs(5);	
    }					 
    IIC_NAck();           //nACK
  
    return receive;
}
/*-------------------------------------------------
* IIC_READ
* ܣ  IICƶλõ
* 룺  address
*   address洢iicdata
 --------------------------------------------------*/
 unsigned char IIC_READ(unsigned char address)
	{
	unsigned char iicdata = 0;
	IIC_READ_Begin:
		IIC_Start();
		IIC_Send_Byte(0xa0);
		if(IIC_Wait_Ack())goto IIC_READ_Begin;
		IIC_Send_Byte(address);				//Ҫݵַ
		if(IIC_Wait_Ack())goto IIC_READ_Begin; 
		IIC_Start();
		IIC_Send_Byte(0xa1);
		if(IIC_Wait_Ack())goto IIC_READ_Begin;
		iicdata=IIC_Read_Byte();
		IIC_Stop();		
		return iicdata;
	}
 /*-------------------------------------------------
* IIC_WRITE
* ܣ  IICdataдƶλaddress
* 룺  addressdata
*   
 --------------------------------------------------*/
void IIC_WRITE(unsigned char address,unsigned char data)
	{
	IIC_WRITE_Begin:
		IIC_Start();
		IIC_Send_Byte(0xa0);
		if(IIC_Wait_Ack())goto IIC_WRITE_Begin;

		IIC_Send_Byte(address);
		if(IIC_Wait_Ack())goto IIC_WRITE_Begin;

		IIC_Send_Byte(data);
		if(IIC_Wait_Ack())goto IIC_WRITE_Begin;

		IIC_Stop();	
	}

/*-------------------------------------------------
* : main 
* ܣ  
* 룺  
*   
 --------------------------------------------------*/
void main()
{
	POWER_INITIAL();				    //ϵͳʼ
	IICReadData = IIC_READ(0x12); 		//ȡ0x12ַEEPROMֵ 
	IIC_WRITE(0x13,~IICReadData); 		//ȡдַ0x13
	while(1)
	{
    	NOP();
	}
}