/* ļTEST_61F02x_PWM.C
* ܣ   FT61F02x-ǿPWMʾ
* IC:      FT61F023 SOP16
*    16M/2T                    
* ˵   оƬPWMǿģʽ,P1A(PC5) 
*		   ž40kHzռձȽĲ
*		   P1B,P1C,P1D,PWMΪͨI/O
*
*               FT61F023  SOP16 
*               ---------------
*  VDD---------|1(VDD)  (VSS)16|--------GND     
*  NC----------|2(PA7)  (PA0)15|---------NC 
*  NC----------|3(PA6)  (PA1)14|---------NC
*  NC----------|4(PA5)  (PA2)13|---------NC
*  P1C---------|5(PC3)  (PA3)12|---------NC
*  P1D---------|6(PC2)  (PC0)11|---------NC
*  NC----------|7(PA4)  (PC1)10|---------NC
*  P1A---------|8(PC5)  (PC4)09|--------P1B
*			    ---------------
*/
//**********************************************************
#include "SYSCFG.h"
//************************궨****************************
#define  unchar     unsigned char 
#define  unint      unsigned int
//PWMŹѡP1XOE 1-PWM 0-ͨI/O
#define  PWM_A_OE  P1AOE 
//PWM
#define  P1ADir	   	TRISC5

volatile   unint    pwm_d=0;      //PWMֵ
volatile   bit      SAFlag;       
/*-------------------------------------------------
* interrupt ISR
* ܣ  жϺ
* ж϶ʱʱ=趨ֵ*ָ
* 				  =16000*0.125uS=2000uS
 --------------------------------------------------*/
void interrupt ISR(void)
{
	if(TMR1IF)
	{
		TMR1IF = 0;
        
        //ֵ=65536-16000=49536=>0XC180
		TMR1L = 0X80;  		//ֵ=>TMR1H=0XC1;TMR1L=0X80
		TMR1H = 0XC1;  		    
	}
}
/*-------------------------------------------------
* POWER_INITIAL
* ܣ  ϵϵͳʼ
* 룺  
*   
 --------------------------------------------------*/	
void POWER_INITIAL (void) 
{
	OSCCON = 0B01110001;	//IRCF=111=16MHz/2=8MHz,0.125us
	INTCON = 0;  			//ݽֹж
    
	PORTA = 0B00000000;		 
	TRISA = 0B00000000;		//PA 1- 0- 
	PORTC = 0B00000000;
	TRISC = 0B11111111; 	//PC 1- 0-

	WPUA = 0;          		//ֹPA
	WPUC = 0   ;       		//ֹPC
	OPTION = 0B00001000;	//Bit3=1,WDT MODE,PS=000=WDT RATE 1:1
    MSCKCON = 0B00000000;
    //Bit6->0,ֹPA4PC5ѹ
	//Bit5->0,TIMER2ʱΪFosc
	//Bit4->0,ֹLVR       
	CMCON0 = 0B00000111; 	//رձȽCxINΪIO
}
/*-------------------------------------------------
* TIMER1_INITIAL
* ܣ  ʱ1ʼ
* öʱʱ=(1/ϵͳʱ)*ָ*ԤƵֵ*(65536-TMR1H:TMR1L)
* 			  =(1/16000000)*2*1*(65536-16000)=2000us
 --------------------------------------------------*/
void TIMER1_INITIAL (void) 
{
	//Ҫж¸ʼֵ
	T1CON = 0B00000000;
    //Bit[5:4]:	00-T2ʱӷƵ 1:1
    //Bit2:	    0-Timer1ʹڲʱ
	//Bit1:		0-T1ʱԴѡڲʱ
	TMR1L = 0X80;  			//ֵTMR1H=0XC1;TMR1L=0X80
	TMR1H = 0XC1;  			
	TMR1IE = 1;				//ʹTMER1ж
	TMR1ON = 1;				//ʹTMER1
	PEIE=1;    				//ʹж
	GIE = 1;   				//ʹȫж
}
/*-------------------------------------------------
* pwm_duty_count
* ܣ  ʮλpwm_dֵֵCCPR1L:CCP1CON<5:4>
* 룺  
*   
 --------------------------------------------------*/	
void pwm_duty_count (void)  
{    
	unint  lsb22;  
	unchar lsb23;            	     	   
	lsb22 = (unchar) pwm_d & 0B00000011;
	CCP1CON =  CCP1CON & 0B11001111;
	lsb22 <<= 4;
	lsb23 = (unchar)lsb22; 
	CCP1CON =  CCP1CON | lsb23; //ֵ10Bit PWMȵĵ2λLSB
	lsb22 = pwm_d >> 2; 		//ֵ10Bit PWMȵĸ8λMSB
	lsb23 = (unchar)lsb22; 
	CCPR1L = lsb23;  
}
/*-------------------------------------------------
* PWM_INITIAL
* ܣ  PWMʼ
* PWM = (PR2+1)*2*(1/Fosc)*T2Ƶֵ
* 			  = (199+1)*2*(1/16000000)*1 = 25us
* 	  PWMƵ=1/PWM=1/25us=40kHz
 --------------------------------------------------*/
void PWM_INITIAL (unchar SET_PR2) 
{
	MSCKCON = 0B00000000;
    //Bit6->0,ֹPA4PC5ѹ
	//Bit5->0,TIMER2ʱΪFosc ; 1ΪTIMER2ʱΪ32MHZ
	//Bit4->0,ֹLVR  
	T2CON = 0B00000000;   		//Bit[1:0]=00, T2ƵΪ1:1
	PR2 = SET_PR2;				//PWM
	CCP1CON = 0B10001101;
    //Bit(7:6)=00;  P1A,P1B,P1C,P1DλͨI/O
	//Bit(5:4)=00;  10Bit PWMռձȵ2λ
	//Bit(3:0)=1101;PWMģʽP1AߵƽЧ,P1B͵ƽЧ

	pwm_duty_count();      		//PWMռձȼ ռձpwm_d/((PR2+1)*4)

	PWM1CON = 0B10000001;
    //Bit7=1,ԶرʱPWMԶ
	//ʱ=Bit<6:0>*(1/Fosc)*2
	//		  =1*(1/16000000)*2=0.125ns
	ECCPAS = 0B00001111;
    //Bit[6:4]=000,ֹԶر
	//Bit[3:2]=11, P1A,P1CرʱΪ̬
	//Bit[1:0]=11, P1B,P1DرʱΪ̬
	PWM1AUX = 0B10000000;
    //Bit7=1,ʹPWM
	//Bit6=0,ʹPWM
	//Bit[5:2]=0011,P1C,P1DΪPWM
	//Bit[1:0]=11,P1A,P1B,P1E,P1FΪIO
	TMR2IF = 0;           		//T2жϱ־λ  
}
/*----------------------------------------------------
* DelayUs
* ܣ  ʱ --16M-2T--ſ1%.
* 룺  Time ʱʱ䳤 ʱʱTime s
*    
 ----------------------------------------------------*/
void DelayUs(unsigned char Time)
{
	unsigned char a;
	for(a=0;a<Time;a++)
	{
		NOP();
	}
}                  
/*----------------------------------------------------
* DelayMs
* ܣ  ʱ
* 룺  Time ʱʱ䳤 ʱʱTime ms
*   
 ----------------------------------------------------*/
void DelayMs(unsigned char Time)
{
	unsigned char a,b;
	for(a=0;a<Time;a++)
	{
		for(b=0;b<5;b++)
		{
		 	DelayUs(197);     //1%
		}
	}
}
/*----------------------------------------------------
* main
* ܣ  
* 룺  
*   
 ----------------------------------------------------*/
void main(void)
{
	POWER_INITIAL(); 
	TIMER1_INITIAL();    
	pwm_d = 10;             
	PWM_INITIAL(99);       	//Tpwm = (99+1)*2*(1/16000000)*1 = 25us = 40kHz	 
							//PWM = 4 * (99+1) = 400
	PWM_A_OE = 1;
    
	P1ADir = 0;
    
	TMR2ON = 1;             //ʹܿT2 	
	SAFlag = 1;
	while(1)
	{
		if(SAFlag == 1) 	//PWMռձ
		{
			pwm_d++;
			if(pwm_d > 400)
			{
				 SAFlag = 0;
			}
		}
		else				//PWMռձȼС
		{
			pwm_d--;
			if(pwm_d == 0)
			{
				SAFlag = 1;
			}
		}
		pwm_duty_count(); 	//PWMռձ
		DelayMs(10);   		//10ms
	}
}