//********************************************************* 
/* ļTEST_61F02x_UART.c
* ܣ   FT61F02x-UART ʾ
* IC     FT61F023 SOP16
*    16M/4T                  
* ˵   ʾвΪ9600RXIOPA2ÿյⲿڷݺTXIO(PA4)
*		   յٷͳȥʼλʱõƽ仯жʶ𣬺͹رյƽ仯жˡ
* 
*                  FT61F023  SOP16 
*                 ----------------
*  VDD-----------|1(VDD)   (VSS)16|-----------GND     
*  NC------------|2(PA7)   (PA0)15|------------NC 
*  NC------------|3(PA6)   (PA1)14|------------NC
*  NC------------|4(PA5)   (PA2)13|----------RXIO
*  NC------------|5(PC3)   (PA3)12|------------NC
*  NC------------|6(PC2)   (PC0)11|------------NC
*  TXIO----------|7(PA4)   (PC1)10|------------NC
*  NC------------|8(PC5)   (PC4)09|------------NC
*			      ----------------
*/
//********************************************************
#include	"SYSCFG.h";
#include	"FT61F02X.h";
//***********************궨***************************
#define		uchar	unsigned char 

#define		TXIO	PA4	//ڵķͽ
#define		RXIO	PA2	//ڵĽս

#define		Bord	208	//ͨʱṩ
uchar RXFLAG = 0;
uchar ReadAPin;
/*-------------------------------------------------
* POWER_INITIAL
* ܣ  MCUʼ
* 룺  
*   
 --------------------------------------------------*/
void POWER_INITIAL(void)
{
	OSCCON = 0B01110001;	//IRCF=111=16MHz/4=4MHz,0.25us
	INTCON = 0;  			//ݽֹж
    
	PORTA = 0B00000000;		
	TRISA = 0B00000100;		//PA 0- 1-
	PORTC = 0B00000000; 
	TRISC = 0B00000000;		//PC 0- 1-
    
    WPUA = 0B00000100;     	//PA˿ 1- 0-
	WPUC = 0B00000000;      //PC˿ 1- 0-
	OPTION = 0B00000000;	//Bit3=0,Timer0 MODE,PS=000=Timer0 RATE 1:2
    MSCKCON = 0B00000000;
    //Bit6->0,ֹPA4PC5ѹ
	//Bit5->0,TIMER2ʱΪFosc
	//Bit4->0,ֹLVR
    
    CMCON0 = 0B00000111; 	//رձȽCxINΪIO 
}
/*----------------------------------------------------
* TIMER0_INITIAL
* ܣ  ʼöʱ0
* TMR0ʱʱ=(1/ϵͳʱƵ)*ָ*ԤƵֵ*TMR0
*				  =(1/16000000)*4*2*208=104us
 ----------------------------------------------------*/
void TIMER0_INITIAL (void)  
{
	OPTION = 0B00000000;
    //Bit5: 	T0CS Timer0ʱԴѡ 
	//			1-ⲿŵƽ仯T0CKI 0-ڲʱ(FOSC/2)
	//Bit4: 	T0CKIŴʽ 1-½ 0-
	//Bit3: 	PSA ԤƵλ 0-Timer0 1-WDT 
	//Bit[2:0]: PS2 8ԤƵ 000 - 1:2
    
	TMR0 = Bord; 
    T0IF = 0;								//T0ж
}
/*-------------------------------------------------
* PA2_Level_Change_INITIAL
* ܣ  PA˿(PA2)ƽ仯жϳʼ
* 룺  
*   
--------------------------------------------------*/
void PA2_Level_Change_INITIAL(void)
{
	TRISA2 =1; 								//SET PA2 INPUT
    ANSEL &= 0xeb;							//PA2PA4ΪIO ר
    CMCON0 = 0B00000111; 					//رձȽCxINΪIO ר
	ReadAPin = PORTA;						//PAƽ仯ж
	PAIF = 0;   							// PA INTжϱ־λ
    IOCA2 = 1;  							//ʹPA2ƽ仯ж
	PAIE = 1;   							//ʹPA INTж
}
/*-------------------------------------------------
* interrupt ISR
* ܣ  жϴʱ0жϺⲿж
* 룺  
*   
* ˵  ʱ104uSжϣӦ9600Ĳ 10000009600=104
 --------------------------------------------------*/
void interrupt ISR(void)			       
{ 
	//ʱ0жϴ
	if(T0IE && T0IF)						//104us
	{
		TMR0 = Bord;						//ע:TMR0¸ֵTMR0ڲ仯
		 
		T0IF = 0;
        T0IE = 0;
	} 
    
	//PAƽ仯ж
	if(PAIE && PAIF)		
    {
		ReadAPin = PORTA; 					//ȡPORTAPAIF־
		PAIF = 0;  							//PAIF־λ
		if(RXIO == 0)
        {
        	PAIE = 0;  						//ȽֹPAƽ仯ж
			IOCA2 = 0;  					//ֹPA2ƽ仯ж
            RXFLAG = 1;
        } 
    }
} 
/*-------------------------------------------------
* WaitTF0
* ܣ  ѯʱжرնʱٴδ򿪶ʱ
* 룺  
*   
 --------------------------------------------------*/
void WaitTF0( void )
{
     while(T0IE);
     T0IE=1;
}
/*-------------------------------------------------
* WByte
* ܣ  UARTһֽ
* 룺  input
*   
 --------------------------------------------------*/
void WByte(uchar input)
{
	                                        //ʼλ
	uchar i=8;
	TXIO = 1;
	TMR0 = Bord;
	T0IE = 1;  
	WaitTF0(); 
	TXIO=0;
	WaitTF0();
	                                        //8λλ
	while(i--)
	{
		if(input&0x01) 						//ȴλ
		{
			TXIO=1;
		}
		else
		{
			TXIO = 0;
		}    
		WaitTF0();
		input=input>>1;
	}
	                                        //Уλ()
	                                        //ͽλ
	TXIO=(bit)1;
	T0IE=0;
} 
/*-------------------------------------------------
* RByte
* ܣ  UARTһֽ
* 룺  
*   Output
 --------------------------------------------------*/
uchar RByte()
{
	uchar Output=0;
	uchar i=8;
	T0IE=1;                          		//Timer0
	TMR0 = Bord;
	WaitTF0();
	T0IE=1;                          		//Timer0
	TMR0 = Bord;
	WaitTF0();                     			//ȹʼλ
	                                        //8λλ
	while(i--)
	{
		Output >>=1;
		if(RXIO) 
        {
        	Output   |=0x80;      			//յλ
        }
		WaitTF0();                 			//λʱ
	}
	T0IE=0;                          		//ֹͣTimer0
	return Output;
}
/*-------------------------------------------------
* main
* ܣ  
* 룺  
*   
 --------------------------------------------------*/
void main(void)
{
	uchar rdata = 0;
	POWER_INITIAL();
    TIMER0_INITIAL();
    PA2_Level_Change_INITIAL();
    GIE = 1; 								//ж
	T0IE = 1;								//ʱ/0ж
    while(1)
    {
        if(RXFLAG)							//ⲿж½ش
        {
        	rdata = RByte();
            WByte(rdata);
        
            IOCA2 =1;  						//ʹPA2ƽ仯ж
			PAIE =1;   						//ʹPA INTж
            RXFLAG = 0;
        }
    }
}