//********************************************************* 
/*  ļTEST_61F02x_VREG.c
*	ܣ  FT61F02x-dacʾ
*   IC:     FT61F023 SOP16
*     16M/2T                    
*   ˵  ѹPA4ƵΪ16KֵΪ3.6Vǲ
*			PA53.6/2=1.8Vѹ
*
*                  FT61F023  SOP16 
*                 ----------------
*  VDD-----------|1(VDD)   (VSS)16|-----------GND     
*  NC------------|2(PA7)   (PA0)15|------------NC 
*  NC------------|3(PA6)   (PA1)14|------------NC
*  NC------------|4(PA5)   (PA2)13|------------NC
*  NC------------|5(PC3)   (PA3)12|------------NC
*  NC------------|6(PC2)   (PC0)11|------------NC
*  VREGP---------|7(PA4)   (PC1)10|------------NC
*  VREGN---------|8(PC5)   (PC4)09|------------NC
*			      ----------------
*/
//*********************************************************
#include "SYSCFG.h"
//***********************궨*****************************
#define  unchar     unsigned char 
 
volatile bit SAFlag;
volatile unchar VREGC;
/*-------------------------------------------------
 *  POWER_INITIAL
 *	ܣ  ϵϵͳʼ
 *  룺  
 *    
 --------------------------------------------------*/	
void POWER_INITIAL (void) 
{ 
	OSCCON = 0B01110001; 	//IRCF=111=16MHz/2T=8MHz,0.125us
	INTCON = 0;          	//ݽֹж
	PORTA = 0B00000000;
	TRISA = 0B00000000;  	//PA 0- 1-
							//PA4->
	PORTC = 0B00000000; 
	TRISC = 0B00000000;	 	//PC 0- 1-,PC5  

	WPUA = 0B00000000;   	//PA˿ 1- 0-

	WPUC = 0B00000000;   	//PC˿ 1- 0-

	OPTION = 0B00001000;	//Bit3=1,WDT MODE,PS=000=WDT RATE 1:1
    MSCKCON = 0B00000000;
    //Bit6->0,ֹPA4PC5ѹ
	//Bit5->0,TIMER2ʱΪFosc
	//Bit4->0,ֹLVR
    
	CMCON0 = 0B00000111; //رձȽCxINΪIO
}
/*----------------------------------------------------
 *	ƣDelayUs
 *	ܣ   ʱ --16M-2T--ſ1%.
 *	Time ʱʱ䳤 ʱʱTime Us
 *	ز 
 ----------------------------------------------------*/
void DelayUs(unsigned char Time)
{
	unsigned char a;
	for(a=0;a<Time;a++)
	{
		NOP();
	}
}                  
/*----------------------------------------------------
 *	ƣDelayMs
 *	ܣ    ʱ 1%
 *	Time ʱʱ䳤 ʱʱTime ms
 *	ز 
 ----------------------------------------------------*/
void DelayMs(unsigned char Time)
{
	unsigned char a,b;
	for(a=0;a<Time;a++)
	{
		for(b=0;b<5;b++)
		{
		 	DelayUs(197);
		}
	}
}
/*-------------------------------------------------
 *  VREG_INITIAL
 *	ܣ  ѹʼ
 *  ѹѹ1=VREG*(VREGHB+1)/32
 *					  =3.6*(31+1)/32 =3.6V
 *		ѹѹ2=VREG*(VREGLB+1)/32
 *					  =3.6*(15+1)/32 = 1.8V
 --------------------------------------------------*/	
void VREG_INITIAL(void) 
{
	VREG_OE = 0;
	VCON1 = 0B00111111; //VREG = 3.6V
	//Bit[6:5] VREGM[1:0]-Dѹѹ(VREG)ѡλ 00-2.4V 01-3.6V 10-4.8V 11-5.3V
	//Bit[4:0] VREGHB[4:0] PA4ѹ 
	
	VCON2 = 0B00001111;
	//Bit[4:0] VREGLB[4:0] PC5ѹ 
	//VOUT = VREG*(VREGLB+1)/32	
		
	VREG_OE = 1;        //ѹʹ
}
/*-------------------------------------------------
 *  :  main 
 *	ܣ  
 *  룺  
 *    
 --------------------------------------------------*/
void main()
{
	POWER_INITIAL();	        //ϵͳʼ
	VREG_INITIAL();		        //ѹʼ
	SAFlag = 1;
	while(1)
	{
		if(SAFlag == 1)         // ǲ
		{
			VREGC++;			//ѹ
			VCON1 &= 0B11100000;
       		VCON1 |= VREGC;
			if(VREGC >= 31)
			{ 
				 SAFlag = 0;
			}
		}
		else	 
		{
			VREGC--;	        //ѹС
			VCON1 &= 0B11100000;
       		VCON1 |= VREGC;
			if(VREGC == 0)
			{
				SAFlag = 1;
			}
		}
		DelayMs(1);             //1ms
	}
}
